{{
FPGA sound driver for sidcog v0.02-20140817
Change from 0.01: some low pass filtering added
Piotr Kardasz, pik33@o2.pl
MIT license, see bottom
}}



VAR

'  long bufnum
  long cog
  long bufnum


pub getbufnum
return @bufnum


PUB start (addr)



bufptr:=addr

stop
cog:=1+cognew(@init, @bufnum)
return cog
  

PUB stop
longfill(bufptr,1,0)
if cog>0
  cogstop(cog-1)
cog := 0
  

DAT
                        org     0                         'initialization

init                    mov     bufptr2,par
                        mov     a2,#128

p102                    mov     a1,inb                 ' wait for upper buffer empty
                        and     a1,#2
                        cmp     a1,#2           wz
              if_nz     jmp     #p102                  '

p11                     mov     a1, inb                'wait for 1 on inb[2] - synchro
                        and     a1, #4
                        cmp     a1,#0           wz
              if_nz     jmp     #p11

p1                      mov     a1, inb                'wait for 1 on inb[2] - synchro
                        and     a1, #4
                        cmp     a1,#4           wz
              if_nz     jmp     #p1

                        rdlong  lsample,bufptr
                        sar     lsample,#16
 '                      mov     rsample,lsample
 '                      add     lsample,filter
 '                      mov     filter,rsample
 '                      sar     filter,#1
                        mov     rsample, lsample
                        shl     rsample,#1
                        add     lsample, rsample
                        shl     rsample,#1
                        add     lsample, rsample
                        sar     lsample,#3
                        mov     rsample,lsample
                        shl     rsample, #16
                        add     lsample,rsample

                        mov     dirb,a2
                        mov     outb,lsample
                        or      dirb,#256
                        add     a2,#1
                        and     a2,#255
                        jmp     #p11

bufptr                  long    0
bufptr2                 long    0

lsample                 res 1
rsample                 res 1
filter                  res 1

a1                      res 1
a2 res 1
                        fit     496

{{

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                  TERMS OF USE: MIT License
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
// modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the
// Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
// COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}}
